@echo off
echo Citra CXI Maker v1.1 (2020-06-16)
echo by eqagunn
echo.
if "%~n1"=="" (
	echo Usage: citra-cxi-maker ^<main-file^> [^<update-file^>]
	pause >nul
	exit /b
)
echo %time:~0,-3% MAIN: %~nx1
if not "%~n2"=="" echo %time:~0,-3% UPDATE: %~nx2
echo %time:~0,-3% Working! Please wait...
echo %time:~0,-3% Preparing MAIN temp folder...
if not exist "%cd%\temp\" md "%cd%\temp\"
if exist "%cd%\temp\%~nx1\" rd /s /q "%cd%\temp\%~nx1\"
md "%cd%\temp\%~nx1\"
echo %time:~0,-3% Setting cxi location for non-cxi input files...
set "ncch0a=%cd%\temp\%~nx1\ncch0.bin"
set "ncch0b=%cd%\temp\%~nx2\ncch0.bin"
echo %time:~0,-3% Checking MAIN input file format...
if "%~x1"==".cia" (
	echo %time:~0,-3% Extracting cxi from MAIN cia...
	tools\ctrtool.exe --contents="%cd%\temp\%~nx1\ncch" %1 >nul 2>&1
	ren "%cd%\temp\%~nx1\ncch.0000.*" ncch0.bin
) else if "%~x1"==".3ds" (
	echo %time:~0,-3% Extracting cxi from MAIN 3ds...
	tools\3dstool.exe -xtf cci %1 -0 "%cd%\temp\%~nx1\ncch0.bin"
) else if "%~x1"==".cci" (
	echo %time:~0,-3% Extracting cxi from MAIN cci...
	tools\3dstool.exe -xtf cci %1 -0 "%cd%\temp\%~nx1\ncch0.bin"
) else if "%~x1"==".cxi" (
	echo %time:~0,-3% Changing cxi location to MAIN input file...
	set "ncch0a=%~dpnx1"
) else (
	echo %time:~0,-3% MAIN file format not supported!
	rd /s /q "%cd%\temp\%~nx1\"
	pause >nul
	exit /b
)
echo %time:~0,-3% Extracting required MAIN cxi contents to decrypt them...
tools\3dstool.exe -xtf cxi "%ncch0a%" ^
--header "%cd%\temp\%~nx1\header0.bin" ^
--exh "%cd%\temp\%~nx1\exh.bin" ^
--exefs "%cd%\temp\%~nx1\exefs.bin" ^
--romfs "%cd%\temp\%~nx1\romfs.bin"
echo %time:~0,-3% Extracting MAIN exefs contents to UPDATE them...
tools\3dstool.exe -xtf exefs "%cd%\temp\%~nx1\exefs.bin" ^
--header "%cd%\temp\%~nx1\exefsheader.bin" ^
--exefs-dir "%cd%\temp\%~nx1\exefs"
if not "%~n2"=="" (
	echo %time:~0,-3% Extracting MAIN romfs contents to UPDATE them...
	tools\3dstool.exe -xtf romfs "%cd%\temp\%~nx1\romfs.bin" ^
	--header "%cd%\temp\%~nx1\romfsheader.bin" ^
	--romfs-dir "%cd%\temp\%~nx1\romfs"
	echo %time:~0,-3% Preparing UPDATE temp folder...
	if exist "%cd%\temp\%~nx2\" rd /s /q "%cd%\temp\%~nx2\"
	md "%cd%\temp\%~nx2\"
	echo %time:~0,-3% Checking UPDATE input file format...
	if "%~x2"==".cia" (
		echo %time:~0,-3% Extracting cxi from UPDATE cia.
		tools\ctrtool.exe --contents="%cd%\temp\%~nx2\ncch" %2 >nul 2>&1
		ren "%cd%\temp\%~nx2\ncch.0000.*" ncch0.bin
	) else if "%~x2"==".3ds" (
		echo %time:~0,-3% Extracting cxi from UPDATE 3ds...
		tools\3dstool.exe -xtf cci %2 -0 "%cd%\temp\%~nx2\ncch0.bin"
	) else if "%~x2"==".cci" (
		echo %time:~0,-3% Extracting cxi from UPDATE cci...
		tools\3dstool.exe -xtf cci %2 -0 "%cd%\temp\%~nx2\ncch0.bin"
	) else if "%~x2"==".cxi" (
		echo %time:~0,-3% Changing cxi location to UPDATE input file...
		set "ncch0b=%~dpnx2"
	) else (
		echo %time:~0,-3% UPDATE file format not supported!
		rd /s /q "%cd%\temp\%~nx2\"
		pause >nul
		exit /b
	)
	echo %time:~0,-3% Extracting required UPDATE cxi contents and overwriting MAIN exh...
	tools\3dstool.exe -xtf cxi "%ncch0b%" ^
	--exh "%cd%\temp\%~nx1\exh.bin" ^
	--exefs "%cd%\temp\%~nx2\exefs.bin" ^
	--romfs "%cd%\temp\%~nx2\romfs.bin"
	echo %time:~0,-3% Extracting UPDATE exefs contents and overwriting MAIN ones...
	tools\3dstool.exe -xtf exefs "%cd%\temp\%~nx2\exefs.bin" ^
	--exefs-dir "%cd%\temp\%~nx1\exefs"
	echo %time:~0,-3% Extracting UPDATE romfs contents and overwriting MAIN ones...
	tools\3dstool.exe -xtf romfs "%cd%\temp\%~nx2\romfs.bin" ^
	--romfs-dir "%cd%\temp\%~nx1\romfs"
	echo %time:~0,-3% Removing UPDATE temp folder...
	rd /s /q "%cd%\temp\%~nx2"
	echo %time:~0,-3% Recreating MAIN romfs...
	tools\3dstool.exe -ctf romfs "%cd%\temp\%~nx1\romfs.bin" ^
	--header "%cd%\temp\%~nx1\romfsheader.bin" ^
	--romfs-dir "%cd%\temp\%~nx1\romfs"
)
echo %time:~0,-3% Unlocking region in MAIN icon...
echo 00002018: ffff ff7f | tools\xxd -r - "%cd%\temp\%~nx1\exefs\icon.icn"
echo %time:~0,-3% Recreating MAIN exefs...
tools\3dstool.exe -ctf exefs "%cd%\temp\%~nx1\exefs.bin" ^
--header "%cd%\temp\%~nx1\exefsheader.bin" ^
--exefs-dir "%cd%\temp\%~nx1\exefs"
echo %time:~0,-3% Recreating MAIN cxi without encrypting...
tools\3dstool.exe -ctf cxi "%~n1-new.cxi" --not-encrypt ^
--header "%cd%\temp\%~nx1\header0.bin" ^
--exh "%cd%\temp\%~nx1\exh.bin" ^
--exefs "%cd%\temp\%~nx1\exefs.bin" ^
--romfs "%cd%\temp\%~nx1\romfs.bin"
echo %time:~0,-3% Removing MAIN temp folder...
rd /s /q "%cd%\temp\%~nx1"
echo %time:~0,-3% Output: %~n1-new.cxi
echo %time:~0,-3% Done!
pause >nul
exit /b
