@echo off
echo Citra CXI Maker v1.2 (2020-06-23)
echo by eqagunn
echo.
if "%~n1"=="" (
	echo Usage: citra-cxi-maker ^<main-file^> [^<update-file^>]
	pause >nul
	exit /b
)
echo %time:~0,-3% MAIN: "%~nx1"
if not "%~n2"=="" echo %time:~0,-3% UPDATE: "%~nx2"
echo %time:~0,-3% Working! Please wait...
echo %time:~0,-3% Preparing MAIN temp folder...
if not exist "%~dp0temp\" md "%~dp0temp\"
if exist "%~dp0temp\%~nx1\" rd /s /q "%~dp0temp\%~nx1\"
md "%~dp0temp\%~nx1\"
echo %time:~0,-3% Setting cxi location for non-cxi input files...
set "ncch0a=%~dp0temp\%~nx1\ncch0.bin"
set "ncch0b=%~dp0temp\%~nx2\ncch0.bin"
echo %time:~0,-3% Checking MAIN input file format...
if /i "%~x1"==".cia" (
	call echo %%time:~0,-3%% Extracting cxi from MAIN cia...
	call "%~dp0tools\ctrtool.exe" --contents="%~dp0temp\%~nx1\ncch" %%1 >nul
	ren "%~dp0temp\%~nx1\ncch.0000.*" ncch0.bin
) else if /i "%~x1"==".3ds" (
	call echo %%time:~0,-3%% Extracting cxi from MAIN 3ds...
	call "%~dp0tools\3dstool.exe" -xtf cci %%1 -0 "%~dp0temp\%~nx1\ncch0.bin"
) else if /i "%~x1"==".cci" (
	call echo %%time:~0,-3%% Extracting cxi from MAIN cci...
	call "%~dp0tools\3dstool.exe" -xtf cci %%1 -0 "%~dp0temp\%~nx1\ncch0.bin"
) else if /i "%~x1"==".cxi" (
	call echo %%time:~0,-3%% Changing cxi location to MAIN input file...
	set "ncch0a=%~f1"
) else (
	call echo %%time:~0,-3%% MAIN file format not supported!
	rd /s /q "%~dp0temp\%~nx1\"
	pause >nul
	exit /b
)
echo %time:~0,-3% Extracting required MAIN cxi contents to decrypt them...
"%~dp0tools\3dstool.exe" -xtf cxi "%ncch0a%" ^
--header "%~dp0temp\%~nx1\header0.bin" ^
--exh "%~dp0temp\%~nx1\exh.bin" ^
--exefs "%~dp0temp\%~nx1\exefs.bin" ^
--romfs "%~dp0temp\%~nx1\romfs.bin"
echo %time:~0,-3% Extracting MAIN exefs contents to UPDATE them...
"%~dp0tools\3dstool.exe" -xtf exefs "%~dp0temp\%~nx1\exefs.bin" ^
--header "%~dp0temp\%~nx1\exefsheader.bin" ^
--exefs-dir "%~dp0temp\%~nx1\exefs"
if not "%~n2"=="" (
	call echo %%time:~0,-3%% Extracting MAIN romfs contents to UPDATE them...
	call "%~dp0tools\3dstool.exe" -xtf romfs "%~dp0temp\%~nx1\romfs.bin" ^
	--header "%~dp0temp\%~nx1\romfsheader.bin" ^
	--romfs-dir "%~dp0temp\%~nx1\romfs"
	call echo %%time:~0,-3%% Preparing UPDATE temp folder...
	if exist "%~dp0temp\%~nx2\" rd /s /q "%~dp0temp\%~nx2\"
	md "%~dp0temp\%~nx2\"
	call echo %%time:~0,-3%% Checking UPDATE input file format...
	if /i "%~x2"==".cia" (
		call echo %%time:~0,-3%% Extracting cxi from UPDATE cia...
		call "%~dp0tools\ctrtool.exe" --contents="%~dp0temp\%~nx2\ncch" %%2 >nul
		ren "%~dp0temp\%~nx2\ncch.0000.*" ncch0.bin
	) else if /i "%~x2"==".3ds" (
		call echo %%time:~0,-3%% Extracting cxi from UPDATE 3ds...
		call "%~dp0tools\3dstool.exe" -xtf cci %2 -0 "%~dp0temp\%~nx2\ncch0.bin"
	) else if /i "%~x2"==".cci" (
		call echo %%time:~0,-3%% Extracting cxi from UPDATE cci...
		call "%~dp0tools\3dstool.exe" -xtf cci %2 -0 "%~dp0temp\%~nx2\ncch0.bin"
	) else if /i "%~x2"==".cxi" (
		call echo %%time:~0,-3%% Changing cxi location to UPDATE input file...
		set "ncch0b=%~f2"
	) else (
		call echo %%time:~0,-3%% UPDATE file format not supported!
		rd /s /q "%~dp0temp\%~nx2\"
		pause >nul
		exit /b
	)
	call echo %%time:~0,-3%% Extracting required UPDATE cxi contents and overwriting MAIN exh...
	call "%~dp0tools\3dstool.exe" -xtf cxi "%%ncch0b%%" ^
	--exh "%~dp0temp\%~nx1\exh.bin" ^
	--exefs "%~dp0temp\%~nx2\exefs.bin" ^
	--romfs "%~dp0temp\%~nx2\romfs.bin"
	call echo %%time:~0,-3%% Extracting UPDATE exefs contents and overwriting MAIN ones...
	call "%~dp0tools\3dstool.exe" -xtf exefs "%~dp0temp\%~nx2\exefs.bin" ^
	--exefs-dir "%~dp0temp\%~nx1\exefs"
	call echo %%time:~0,-3%% Extracting UPDATE romfs contents and overwriting MAIN ones...
	call "%~dp0tools\3dstool.exe" -xtf romfs "%~dp0temp\%~nx2\romfs.bin" ^
	--romfs-dir "%~dp0temp\%~nx1\romfs"
	call echo %%time:~0,-3%% Removing UPDATE temp folder...
	rd /s /q "%~dp0temp\%~nx2"
	call echo %%time:~0,-3%% Recreating MAIN romfs...
	call "%~dp0tools\3dstool.exe" -ctf romfs "%~dp0temp\%~nx1\romfs.bin" ^
	--header "%~dp0temp\%~nx1\romfsheader.bin" ^
	--romfs-dir "%~dp0temp\%~nx1\romfs"
)
echo %time:~0,-3% Unlocking region in MAIN icon...
echo 00002018: ffff ff7f | "%~dp0tools\xxd.exe" -r - "%~dp0temp\%~nx1\exefs\icon.icn"
echo %time:~0,-3% Recreating MAIN exefs...
"%~dp0tools\3dstool.exe" -ctf exefs "%~dp0temp\%~nx1\exefs.bin" ^
--header "%~dp0temp\%~nx1\exefsheader.bin" ^
--exefs-dir "%~dp0temp\%~nx1\exefs"
echo %time:~0,-3% Recreating MAIN cxi without encrypting...
"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0%~n1-new.cxi" --not-encrypt ^
--header "%~dp0temp\%~nx1\header0.bin" ^
--exh "%~dp0temp\%~nx1\exh.bin" ^
--exefs "%~dp0temp\%~nx1\exefs.bin" ^
--romfs "%~dp0temp\%~nx1\romfs.bin"
echo %time:~0,-3% "%~n1-new.cxi" ready!
echo %time:~0,-3% Removing MAIN temp folder...
rd /s /q "%~dp0temp\%~nx1"
echo %time:~0,-3% Done!
pause >nul
exit /b
